Imports System.Drawing
Imports System.Drawing.Drawing2D
Imports vb = Microsoft.VisualBasic
Public Class Form1

    Dim Server As New SQLDMO.SQLServer
    Dim Connected As Boolean

#Region "ConnectToServer - Sub"
    Private Sub ConnectToServer()
        Try
            If TrustedConnection.Checked = True Then
                Server.LoginSecure = True
            End If
            Server.Connect(TxtServer.Text, TxtUserName.Text, TxtPassword.Text)
            Connected = True
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub
#End Region

#Region "Fill_DataBase_Combo - Sub"
    Private Sub Fill_DataBase_Combo()
        Try
            Dim _DataBase As SQLDMO.Database
            Combo_Database.Items.Clear()
            For Each _DataBase In Server.Databases
                Combo_Database.Items.Add(_DataBase.Name)
            Next
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub
#End Region

#Region "Combo_Database_Click"
    Private Sub Combo_Database_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Combo_Database.Click
        If Connected = False Then
            ConnectToServer()
            Fill_DataBase_Combo()
        End If

    End Sub
#End Region

#Region "BtnBackup_Click"
    Private Sub BtnBackup_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnBackup.Click
        Dim _BackupDevice As New SQLDMO.BackupDevice
        Dim _Backup As New SQLDMO.Backup
        Dim _BackupName As String
        Dim tmp As String()
        Try
            SaveFileDialog1.Filter = "SQL Server Backup Files (*.BAK)|*.BAK"
            SaveFileDialog1.FileName = "*.BAK"
            SaveFileDialog1.AddExtension = True
            SaveFileDialog1.ShowDialog()

            tmp = SaveFileDialog1.FileName.Split("\")
            _BackupName = tmp(tmp.GetUpperBound(0))

            With _BackupDevice
                .Type = SQLDMO.SQLDMO_DEVICE_TYPE.SQLDMODevice_DiskDump
                .PhysicalLocation = SaveFileDialog1.FileName
                .Name = _BackupName
            End With

            'Server.BackupDevices.Add(_BackupDevice)

            With _Backup
                .Action = SQLDMO.SQLDMO_BACKUP_TYPE.SQLDMOBackup_Database
                .BackupSetDescription = Me.Combo_Database.Text & "_Backup_" & Now.Date
                .BackupSetName = vb.Left(_BackupName, Len(_BackupName) - 4)
                '.Devices = _BackupDevice.Name
                .Files = SaveFileDialog1.FileName
                .Database = Me.Combo_Database.Text
            End With

        Catch ex As Exception
            MsgBox(ex.Message)
        Finally
            _Backup.SQLBackup(Server)
            MsgBox("The Backup Operation has been completed successfully.")
        End Try

    End Sub
#End Region

#Region "TrustedConnection_CheckedChanged"
    Private Sub TrustedConnection_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TrustedConnection.CheckedChanged
        If TrustedConnection.Checked = True Then
            Me.TxtPassword.Enabled = False
            Me.TxtUserName.Enabled = False
        Else
            Me.TxtPassword.Enabled = True
            Me.TxtUserName.Enabled = True
        End If
    End Sub
#End Region

#Region "Form_Paint"
    Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Me.Paint
        Dim Br As New LinearGradientBrush(New Point(0, 0), New Point(Me.Width, Me.Height), Color.LightBlue, Color.CornflowerBlue)
        Dim Rect As New Rectangle(0, 0, Me.Width, Me.Height)
        e.Graphics.FillRectangle(Br, Rect)
    End Sub
#End Region

    Private Sub Combo_Database_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Combo_Database.SelectedIndexChanged
        Me.BtnBackup.Enabled = True
    End Sub
End Class
